#include <iostream>  
#include <string>
#include <list>       
#include <vector>
#include <sys/time.h>
using namespace std;

void printVector(vector<int> & intVector)
{
  vector<int>::iterator intIterator = intVector.begin();
  while (intIterator != intVector.end())
    {
      cout << (*intIterator) << " ";
      intIterator ++;
    }
  cout << endl;
}

void printList(list<int> & intList)
{
  list<int>::iterator intIterator = intList.begin();
  while (intIterator != intList.end())
    {
      cout << (*intIterator) << " ";
      intIterator ++;
    }
  cout << endl;
}

void computeTime(struct timeval * tp1, struct timeval * tp2)
{
  cout << " " <<  1e-6 * ((tp2 -> tv_usec) - (tp1 ->tv_usec)) + 
    ((tp2 -> tv_sec) - (tp1 -> tv_sec)) << endl;
}

void insertVectorFront(int vSize)
{
  struct timeval tp1;
  struct timeval tp2;
  vector<int> intVector;
  gettimeofday(& tp1, NULL);  
  for (int iterCnt = 0; iterCnt < vSize; iterCnt ++)
    { 
      intVector.insert(intVector.begin(), iterCnt); 
    }
  gettimeofday(& tp2, NULL);  
  cout << "insertVectorFront(" << vSize << ")";
  computeTime(& tp1, & tp2);
  // printVector(intVector);
}

void insertVectorBack(int vSize)
{
  struct timeval tp1;
  struct timeval tp2;
  vector<int> intVector;
  gettimeofday(& tp1, NULL);  
  for (int iterCnt = 0; iterCnt < vSize; iterCnt ++)
    { 
      intVector.push_back(iterCnt); 
    }
  gettimeofday(& tp2, NULL);  
  cout << "insertVectorBack(" << vSize << ")";
  computeTime(& tp1, & tp2);
  // printVector(intVector);
}

void insertListFront(int vSize)
{
  struct timeval tp1;
  struct timeval tp2;
  list<int> intList;
  gettimeofday(& tp1, NULL);  
  for (int iterCnt = 0; iterCnt < vSize; iterCnt ++)
    { 
      intList.insert(intList.begin(), iterCnt); 
    }
  gettimeofday(& tp2, NULL);  
  cout << "insertListFront(" << vSize << ")";
  computeTime(& tp1, & tp2);
  // printList(intList);
}

void insertListBack(int vSize)
{
  struct timeval tp1;
  struct timeval tp2;
  list<int> intList;
  gettimeofday(& tp1, NULL);  
  for (int iterCnt = 0; iterCnt < vSize; iterCnt ++)
    { 
      intList.push_back(iterCnt); 
    }
  gettimeofday(& tp2, NULL);  
  cout << "insertListBack(" << vSize << ")";
  computeTime(& tp1, & tp2);
  // printList(intList);
}

int main(int argc, char * argv[])
{
  const int maxPower = 7;
  int curPower = 0;
  int containerSize = 1;
  while (curPower < maxPower)
    {
      cout << endl;
      insertVectorFront(containerSize);
      insertVectorBack(containerSize);
      insertListFront(containerSize);
      insertListBack(containerSize);
      curPower ++;
      containerSize *= 10;      
    }
}
