import java.util.*;
class containerperformance
{
    static void printVector(Vector<Integer> intVector)
    {
	ListIterator<Integer> iter = intVector.listIterator();
	while (iter.hasNext())
	    {
		System.out.print(iter.next() + " ");
	    }
	System.out.println("");
    }

    static void printList(List<Integer> intList)
    {
	ListIterator<Integer> iter = intList.listIterator();
	while (iter.hasNext())
	    {
		System.out.print(iter.next() + " ");
	    }
	System.out.println("");
    }

    static void computeTime(long t1, long t2)
    {
	System.out.println(1e-3 * (t2 - t1));
    }

    static void insertVectorFront(int vSize)
    {
	Vector<Integer> intVector = new Vector<Integer>();
	long t1 = System.currentTimeMillis();
	for (int iterCnt = 0; iterCnt < vSize; iterCnt ++)
	    { 
		intVector.add(0, iterCnt); 
	    }
	long t2 = System.currentTimeMillis();
	System.out.print("insertVectorFront(" + vSize + ") ");
	computeTime(t1, t2);
	// printVector(intVector);
    }

    static void insertVectorBack(int vSize)
    {
	Vector<Integer> intVector = new Vector<Integer>();
	long t1 = System.currentTimeMillis();
	for (int iterCnt = 0; iterCnt < vSize; iterCnt ++)
	    { 
		intVector.add(iterCnt); 
	    }
	long t2 = System.currentTimeMillis();
	System.out.print("insertVectorBack(" + vSize + ") ");
	computeTime(t1, t2);
	// printVector(intVector);
    }

    static void insertListFront(int vSize)
    {
	List<Integer> intList = new LinkedList<Integer>();
	long t1 = System.currentTimeMillis();
	for (int iterCnt = 0; iterCnt < vSize; iterCnt ++)
	    { 
		intList.add(0, iterCnt); 
	    }
	long t2 = System.currentTimeMillis();
	System.out.print("insertListFront(" + vSize + ") ");
	computeTime(t1, t2);
	// printList(intList);
    }

    static void insertListBack(int vSize)
    {
	List<Integer> intList = new LinkedList<Integer>();
	long t1 = System.currentTimeMillis();
	for (int iterCnt = 0; iterCnt < vSize; iterCnt ++)
	    { 
		intList.add(iterCnt); 
	    }
	long t2 = System.currentTimeMillis();
	System.out.print("insertListBack(" + vSize + ") ");
	computeTime(t1, t2);
	// printList(intList);
    }

    public static void main(String argv[])
    {
	final int maxPower = 7;
	int curPower = 0;
	int containerSize = 1;
	while (curPower < maxPower)
	    {
		System.out.println("");
		insertVectorFront(containerSize);
		insertVectorBack(containerSize);
		insertListFront(containerSize);
		insertListBack(containerSize);
		curPower ++;
		containerSize *= 10;
	    }
    }
}
